// alien.h: interface for the Alien class.
// -Kyoung Shin Park (2009 Spring)
//////////////////////////////////////////////////////////////////////
#ifndef __ALIEN_H__
#define __ALIEN_H__

#include <list>

class AlienInfo
{
public:
	AlienInfo(float x, float y, float sz);

	void set(float x, float y);		// set its position & range
	void move(float ix, float iy);	// move its position by increment value
	bool intersect(float x, float y) const;	// check the collision with the point (x, y)
	void draw();					// draw an alien

protected:
	// member variables
	float cx, cy, size;
	float xmin, xmax, ymin, ymax;
};

class Alien
{
public:
	Alien(float dxmin, float dymin, float dxmax, float dymax, float sz);
	virtual ~Alien();		// cleanup

	void reset();			// if it's called, erase all live aliens and then re-initialize the aliens
	void add(AlienInfo *a);	// add new alien
	void eraseAll();		// erase all aliens
	bool deadAll() const;	// return true if all aliens are dead
	void update(float x, float y);	// for each alien check the collision, and then erase it if it's intersected 
	void move(float ix, float iy);	// move the whole aliens position by increment value
	void draw();			// draw all aliens

protected:
	float sizeOfAlien;
	int numberOfAliens;
	int dimxmin, dimxmax, dimymin, dimymax; 
	std::list<AlienInfo *> alienList;
};

#endif

