// bullet.h: interface for the Bullet class.
// -Kyoung Shin Park (2009 Spring)
//////////////////////////////////////////////////////////////////////
#ifndef __BULLET_H__
#define __BULLET_H__

#include <list>

const float BULLET_SPEED = 1.0;
const float BULLET_LIFE_TIME = 200.0;

class BulletInfo 
{
public:
	BulletInfo() : cx(0.0), cy(0.0), life(0.0) {} 
	BulletInfo(float x, float y) : cx(x), cy(y), life(0.0) {}

	float cx, cy;
	float life;
};

class Bullet
{
public:
	Bullet() {};
	virtual ~Bullet() {};
	void add(BulletInfo b);	// add new bullet
	void eraseAll();		// erase all live bullets
	void update(float dt);	// for each bullet, accumulate the bullet's life time and if the life time exceed the BULLET_LIFE_TIME then kill it. otherwise, update its position
	void draw();			// draw all live bullets

	std::list<BulletInfo> bulletList; // list of bullet
};

#endif
