#include <list>
#include <GL/glut.h>
#include <GL/gl.h>
#include <math.h>
#include "ship.h"
#include "bullet.h"
#include "alien.h"

const float WORLDXMIN = 0.0;
const float WORLDXMAX = 200.0;
const float WORLDYMIN = 0.0;
const float WORLDYMAX = 200.0;

const float ALIEN_UPDATE_PERIOD = 500.0;
const float ALIEN_SIZE = 15.2;

Ship ship((WORLDXMAX - WORLDXMIN) / 2, 0.0, WORLDXMIN, WORLDXMAX);
Bullet bullets;
Alien aliens(0, 160, 200, 200, ALIEN_SIZE);

void display()
{
	glClearColor(0.0, 0.0, 0.0, 0.0);
	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);

	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();
	gluOrtho2D(WORLDXMIN, WORLDXMAX, WORLDYMIN, WORLDYMAX);

	// draw

	glutSwapBuffers();
}

void keyboard(unsigned char key, int x, int y)
{
	switch (key)  
	{    
	case 0x1B:    
	case 'q':    
	case 'Q':
		exit(0);    
		break;  
	case ' ':
		break;
	}
	glutPostRedisplay();
}

void specialkey(int key, int x, int y)
{
    glutPostRedisplay();
}

void update()
{
	static int currentTime, deltaTime, prevTime = 0; 
	static int startTime, elapsedTime = 0;
	currentTime = glutGet(GLUT_ELAPSED_TIME);
	deltaTime = currentTime - prevTime;
	prevTime = currentTime;

	glutPostRedisplay();
}

int main(int argc, char** argv)
{
	glutInit(&argc, argv);
	glutInitDisplayMode(GLUT_RGB | GLUT_DOUBLE);
	glutInitWindowSize(400, 400); 
	glutInitWindowPosition(0,0);
	glutCreateWindow(argv[0]);
	glutDisplayFunc(display);
	glutKeyboardFunc(keyboard);
	glutSpecialFunc(specialkey);
	glutIdleFunc(update);
	glutMainLoop();	
}
